SystemOrganization addCategory: #Kozen!

Object subclass: #ARObject
	instanceVariableNames: 'value'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kozen'!

ARObject subclass: #ARDivBlock
	instanceVariableNames: 'attribute'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kozen'!

!ARDivBlock commentStamp: 'StephaneDucasse 1/3/2012 22:09' prior: 0!
<div id="header">

	attribute = id 
	tag = header!

!ARDivBlock methodsFor: 'as yet unclassified' stamp: 'StephaneDucasse 1/3/2012 11:19'!
accept: aVisitor

	aVisitor visitDivBlock: self.
! !

!ARDivBlock methodsFor: 'as yet unclassified' stamp: 'StephaneDucasse 1/3/2012 22:11'!
attribute
	^ attribute! !

!ARDivBlock methodsFor: 'as yet unclassified' stamp: 'StephaneDucasse 1/3/2012 22:11'!
attribute: aString
	
	attribute := aString! !

ARObject subclass: #ARImage
	instanceVariableNames: 'image'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kozen'!

!ARImage methodsFor: 'accessing' stamp: 'StephaneDucasse 1/3/2012 11:20'!
accept: aVisitor

	aVisitor visitImage: self.
! !

!ARImage methodsFor: 'accessing' stamp: 'StephaneDucasse 1/3/2012 11:17'!
image
	^ image! !

!ARImage methodsFor: 'accessing' stamp: 'StephaneDucasse 1/3/2012 11:17'!
image: anObject
	image := anObject! !

ARImage subclass: #ARLinkedImage
	instanceVariableNames: 'link'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kozen'!

!ARLinkedImage methodsFor: 'visit' stamp: 'StephaneDucasse 1/3/2012 22:51'!
accept: aVisitor

	aVisitor visitLinkedImage: self! !

!ARLinkedImage methodsFor: 'accessing' stamp: 'StephaneDucasse 1/3/2012 22:51'!
link
	^ link! !

!ARLinkedImage methodsFor: 'accessing' stamp: 'StephaneDucasse 1/3/2012 22:51'!
link: anObject
	link := anObject! !

ARObject subclass: #ARItem
	instanceVariableNames: 'name link'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kozen'!

ARItem subclass: #ARBlockItem
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kozen'!

!ARBlockItem commentStamp: 'StephaneDucasse 1/3/2012 23:00' prior: 0!
ARBlockItem is an item of a floating block. For example like on the right of my web page.!

!ARBlockItem methodsFor: 'visit' stamp: 'StephaneDucasse 1/3/2012 23:04'!
accept: aVisitor

	aVisitor visitRightBlockItem: self.
! !

!ARItem methodsFor: 'as yet unclassified' stamp: 'StephaneDucasse 1/3/2012 22:59'!
link
	
	^ link! !

!ARItem methodsFor: 'as yet unclassified' stamp: 'StephaneDucasse 1/3/2012 22:59'!
link: aName

	link := aName! !

!ARItem methodsFor: 'as yet unclassified' stamp: 'StephaneDucasse 1/3/2012 22:59'!
name

	^ name! !

!ARItem methodsFor: 'as yet unclassified' stamp: 'StephaneDucasse 1/3/2012 22:59'!
name:  aString

	name := aString! !

ARItem subclass: #ARMenuItem
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kozen'!

!ARMenuItem methodsFor: 'as yet unclassified' stamp: 'StephaneDucasse 1/2/2012 22:57'!
accept: aVisitor

	aVisitor visitMenuItem: self.
! !

ARObject subclass: #ARList
	instanceVariableNames: 'elements'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kozen'!

!ARList methodsFor: 'elements' stamp: 'StephaneDucasse 1/3/2012 22:47'!
addElement: anElement

	elements add: anElement! !

!ARList methodsFor: 'elements' stamp: 'StephaneDucasse 1/3/2012 22:47'!
elements

	^ elements! !

!ARList methodsFor: 'initialize' stamp: 'StephaneDucasse 1/3/2012 22:46'!
initialize

	super initialize.
	elements := OrderedCollection new.! !

ARList subclass: #ARMenu
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kozen'!

!ARMenu methodsFor: 'visit' stamp: 'StephaneDucasse 1/2/2012 22:56'!
accept: aVisitor

	aVisitor visitMenu: self.
! !

ARList subclass: #ARRightBlock
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kozen'!

!ARRightBlock methodsFor: 'visit' stamp: 'StephaneDucasse 1/3/2012 22:49'!
accept: aVisitor

	aVisitor visitRightBlock: self.! !

!ARObject methodsFor: 'accessing' stamp: 'StephaneDucasse 1/2/2012 22:47'!
accept: aVisitor
	! !

!ARObject methodsFor: 'accessing' stamp: 'StephaneDucasse 1/3/2012 22:09'!
value
	^ value! !

!ARObject methodsFor: 'accessing' stamp: 'StephaneDucasse 1/3/2012 22:10'!
value: aString
	value := aString! !

ARObject subclass: #ARPage
	instanceVariableNames: 'title elements head name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kozen'!

!ARPage methodsFor: 'visiting' stamp: 'StephaneDucasse 1/2/2012 22:57'!
accept: aVisitor

	aVisitor visitPage: self.
! !

!ARPage methodsFor: 'adding' stamp: 'StephaneDucasse 1/2/2012 21:54'!
addElement: anElement

	elements add: anElement.! !

!ARPage methodsFor: 'initialize-release' stamp: 'StephaneDucasse 1/1/2012 23:03'!
defaultHead

	^ '<head>
		<link rel="stylesheet" href="CSS/stef.css"/>
		<title>Dr. Stphane Ducasse</title>
   </head>'! !

!ARPage methodsFor: 'initialize-release' stamp: 'StephaneDucasse 1/2/2012 22:39'!
defaultName

	^ 'Home'! !

!ARPage methodsFor: 'initialize-release' stamp: 'StephaneDucasse 1/1/2012 22:12'!
defaultTitle

	^ 'Dr. Stphane Ducasse'! !

!ARPage methodsFor: 'accessing' stamp: 'StephaneDucasse 1/2/2012 22:54'!
elements

	^ elements! !

!ARPage methodsFor: 'accessing' stamp: 'StephaneDucasse 1/2/2012 21:53'!
head

	^ head! !

!ARPage methodsFor: 'accessing' stamp: 'StephaneDucasse 1/2/2012 22:39'!
header

	^ '<div id="header">
         <div id="headerSiteTitle">Stphane Ducasse</div>
         <div id="headerPageTitle">', self name, '</div>
      </div>'! !

!ARPage methodsFor: 'accessing' stamp: 'StephaneDucasse 1/3/2012 22:26'!
headerPageTitle

	^ self name
! !

!ARPage methodsFor: 'accessing' stamp: 'StephaneDucasse 1/3/2012 22:23'!
headerSiteTitle

	^ 'Stphane Ducasse'! !

!ARPage methodsFor: 'initialize-release' stamp: 'StephaneDucasse 1/2/2012 22:39'!
initialize

	super initialize.
	elements := OrderedCollection new.
	head := self defaultHead.
	title := self defaultTitle.
	name := self defaultName.! !

!ARPage methodsFor: 'accessing' stamp: 'StephaneDucasse 1/2/2012 21:52'!
metaHead

	^ '<?xml version="1.0" encoding="ISO-8859-1"?>
	<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en">'! !

!ARPage methodsFor: 'accessing' stamp: 'StephaneDucasse 1/2/2012 22:40'!
name 

	^ name! !

!ARPage methodsFor: 'accessing' stamp: 'StephaneDucasse 1/2/2012 22:40'!
name: aString
	name := aString! !

ARObject subclass: #ARSection
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kozen'!

Object subclass: #ARSite
	instanceVariableNames: 'stream'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kozen'!

!ARSite methodsFor: 'initialize' stamp: 'StephaneDucasse 1/2/2012 22:24'!
contents

	^ stream contents! !

!ARSite methodsFor: 'initialize' stamp: 'StephaneDucasse 1/2/2012 22:23'!
initialize

	super initialize.
	stream := ReadWriteStream on: (String new: 10000).! !

Object subclass: #ARVisitor
	instanceVariableNames: 'stream'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kozen'!

!ARVisitor commentStamp: 'StephaneDucasse 1/1/2012 22:52' prior: 0!
ARVisitor is a web site visitor. !

!ARVisitor methodsFor: 'private' stamp: 'StephaneDucasse 1/3/2012 21:19'!
addComment: aComment
	stream 
		nextPutAll: '    <!!--'; 
		nextPutAll: aComment; 
		nextPutAll: ' -->'.
	! !

!ARVisitor methodsFor: 'operation' stamp: 'StephaneDucasse 1/4/2012 13:12'!
bodyEncodings
	^ 'body'! !

!ARVisitor methodsFor: 'operation' stamp: 'StephaneDucasse 1/2/2012 22:19'!
contents

	^ stream contents! !

!ARVisitor methodsFor: 'private' stamp: 'StephaneDucasse 1/3/2012 21:38'!
cr

	stream nextPut: Character cr! !

!ARVisitor methodsFor: 'private' stamp: 'StephaneDucasse 1/3/2012 11:31'!
div

	self startBalise: 'div'! !

!ARVisitor methodsFor: 'operation' stamp: 'StephaneDucasse 1/4/2012 13:12'!
divEncodings
	^ 'div'! !

!ARVisitor methodsFor: 'private' stamp: 'StephaneDucasse 1/3/2012 21:37'!
endBalise: aString

	stream nextPut: $< ; nextPut: $/.
	stream nextPutAll: aString.
	stream nextPut: $>. 
	

	! !

!ARVisitor methodsFor: 'private' stamp: 'StephaneDucasse 1/3/2012 21:38'!
endBaliseCr: aString

	self endBalise: aString.
	self cr.
	

	! !

!ARVisitor methodsFor: 'private' stamp: 'StephaneDucasse 1/3/2012 11:33'!
endBody

	self endBalise: 'body'.! !

!ARVisitor methodsFor: 'private' stamp: 'StephaneDucasse 1/3/2012 11:32'!
endDiv

	self endBalise: 'div'! !

!ARVisitor methodsFor: 'operation' stamp: 'StephaneDucasse 1/4/2012 13:12'!
ensureAttribute: aKey value: aTag div: aBlock
	"ensureDiv: aBlock key: id tagged: menu ->
		div id='menu'"

	self startBalise: self divEncodings attribute: aKey value: aTag.
	aBlock cull: stream.
	self endDiv.
	self addComment: 'Closing ' , aTag.
	self cr! !

!ARVisitor methodsFor: 'operation' stamp: 'StephaneDucasse 1/4/2012 13:13'!
ensureBody: aBlock
	self startBalise: self bodyEncodings.
	aBlock cull: stream.
	self endBalise: self bodyEncodings! !

!ARVisitor methodsFor: 'operation' stamp: 'StephaneDucasse 1/3/2012 11:25'!
ensureDiv: aBlock
	
	self div.
	aBlock value: stream.
	self endDiv! !

!ARVisitor methodsFor: 'private' stamp: 'StephaneDucasse 1/3/2012 11:31'!
ensureTag: aString for: aBlock

	self startBalise: aString.
	aBlock value: stream.
	self endBalise: aString! !

!ARVisitor methodsFor: 'visit' stamp: 'StephaneDucasse 1/4/2012 13:14'!
headerEncodings
	^ 'header'! !

!ARVisitor methodsFor: 'visit' stamp: 'StephaneDucasse 1/4/2012 13:15'!
headerPageTitleEncodings
	^ 'headerPageTitle'! !

!ARVisitor methodsFor: 'visit' stamp: 'StephaneDucasse 1/4/2012 13:14'!
headerSideTitleEncodings
	^ 'headerSideTitle'! !

!ARVisitor methodsFor: 'private' stamp: 'StephaneDucasse 1/3/2012 21:31'!
href: url name: aString

	stream 
		nextPutAll: '<a ref="';
		nextPutAll: url;
		nextPutAll: '">';
		nextPutAll: aString;
		nextPutAll: '</a>'! !

!ARVisitor methodsFor: 'initialize' stamp: 'StephaneDucasse 1/2/2012 22:18'!
initialize

	super initialize.
	stream := ReadWriteStream on: (String new: 10000).! !

!ARVisitor methodsFor: 'visit' stamp: 'StephaneDucasse 1/4/2012 13:13'!
menuEncodings
	^ 'menu'! !

!ARVisitor methodsFor: 'visit' stamp: 'StephaneDucasse 1/4/2012 13:15'!
personalDetailsEncodings
	^ 'personalDetails'! !

!ARVisitor methodsFor: 'visit' stamp: 'StephaneDucasse 1/4/2012 14:57'!
personalDetailsItemEncodings
	^ 'personalDetailsItem'! !

!ARVisitor methodsFor: 'private' stamp: 'StephaneDucasse 1/3/2012 11:33'!
startBalise: aString

	stream nextPut: $<.
	stream nextPutAll: aString.
	stream nextPut: $>.
	stream nextPut: Character cr.

	! !

!ARVisitor methodsFor: 'private' stamp: 'StephaneDucasse 1/3/2012 22:38'!
startBalise:  balise attribute: aKey value: aTag.
	
	stream 
		nextPut: $<; 
		nextPutAll: balise ; 
		nextPut: Character space ; 
		nextPutAll: aKey ; 
		nextPutAll: '="' ; 
		nextPutAll: aTag; 
		nextPutAll: '">'.! !

!ARVisitor methodsFor: 'private' stamp: 'StephaneDucasse 1/3/2012 11:33'!
startBody

	self startBalise: 'body'.! !

!ARVisitor methodsFor: 'visit' stamp: 'StephaneDucasse 1/4/2012 13:13'!
tocEncodings
	^ 'toc'! !

!ARVisitor methodsFor: 'visit' stamp: 'StephaneDucasse 1/4/2012 13:14'!
tocItemEncodings
	^ 'tocItem'! !

!ARVisitor methodsFor: 'visit' stamp: 'StephaneDucasse 1/2/2012 22:47'!
visit: anElement

	anElement accept: self! !

!ARVisitor methodsFor: 'visit' stamp: 'StephaneDucasse 1/3/2012 21:21'!
visitImage: anImage

	self ensureDiv: [ :aStream | 
			aStream 
				nextPutAll: '<a href="'; 
				nextPutAll: anImage link; 
				nextPutAll: '"><img src="'; nextPutAll: anImage image; 
				nextPutAll: '"></a>' ; 
				nextPut: Character cr]! !

!ARVisitor methodsFor: 'visit' stamp: 'StephaneDucasse 1/3/2012 22:53'!
visitLinkedImage: aLinkedImage

	self ensureDiv: [ :aStream | 
			aStream 
				nextPutAll: '"<img src="'; nextPutAll: aLinkedImage image; 
				nextPutAll: '">' ; 
				nextPut: Character cr]! !

!ARVisitor methodsFor: 'visit' stamp: 'StephaneDucasse 1/4/2012 13:13'!
visitMenu: aMenu
	self
		ensureAttribute: 'id'
		value: self menuEncodings
		div: [ 
			self
				ensureAttribute: 'id'
				value: self tocEncodings
				div: [ aMenu elements do: [ :each | self visit: each ] separatedBy: [ stream cr ] ] ]! !

!ARVisitor methodsFor: 'visit' stamp: 'StephaneDucasse 1/4/2012 13:14'!
visitMenuItem: aMenuItem
	self ensureAttribute: 'id' value: self tocItemEncodings div: [ self href: aMenuItem link name: aMenuItem name ]! !

!ARVisitor methodsFor: 'visit' stamp: 'StephaneDucasse 1/4/2012 13:15'!
visitPage: aPage
	stream nextPutAll: aPage metaHead.
	stream nextPutAll: aPage head.
	self
		ensureBody: [ 
			self
				ensureAttribute: 'id'
				value: self headerEncodings
				div: [ 
					self ensureAttribute: 'id' value: self headerSideTitleEncodings div: [ stream nextPutAll: aPage headerSiteTitle ].
					self ensureAttribute: 'id' value: self headerPageTitleEncodings div: [ stream nextPutAll: aPage headerPageTitle ] ].
			aPage elements do: [ :each | self visit: each ] ]! !

!ARVisitor methodsFor: 'visit' stamp: 'StephaneDucasse 1/4/2012 13:15'!
visitRightBlock: aBlock
	self
		ensureAttribute: 'id'
		value: self personalDetailsEncodings
		div: [ aBlock elements do: [ :each | self visit: each ] separatedBy: [ stream cr ] ]! !

!ARVisitor methodsFor: 'visit' stamp: 'StephaneDucasse 1/4/2012 14:57'!
visitRightBlockItem: anItem
	self ensureAttribute: 'id' value: self personalDetailsItemEncodings div: [ self href: anItem link name: anItem name ]! !

!ARVisitor methodsFor: 'visit' stamp: 'StephaneDucasse 1/1/2012 22:47'!
visitSite: aSite

	! !

Object subclass: #StefSite
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kozen'!

StefSite class
	instanceVariableNames: 'site menu page'!

StefSite class
	instanceVariableNames: 'site menu page'!

!StefSite class methodsFor: 'create site' stamp: 'StephaneDucasse 1/4/2012 09:39'!
block

	menu := ARRightBlock new.
	menu addElement: (ARImage new image: 'StefFingerOnNose.jpg'; yourself).
	menu addElement: (ARBlockItem new name: 'INRIA'; link: 'http://www.inria.fr/'; yourself).
	menu addElement: (ARBlockItem new name: 'RMOD'; link: 'http://rmod.lille.inria.fr/'; yourself).
	menu addElement: (ARBlockItem new name: 'Stephane-Ducasse(@)INRIA.FR'; link: 'mailto:stephane.ducasse@inria.fr'; yourself).
	^ menu
	! !

!StefSite class methodsFor: 'create site' stamp: 'StephaneDucasse 1/2/2012 22:35'!
createSite
	"self createSite"
	
	| visitor |
	visitor := ARVisitor new.
	visitor visitPage: self site.
	^ visitor contents! !

!StefSite class methodsFor: 'create site' stamp: 'StephaneDucasse 1/2/2012 22:16'!
menu

	menu := ARMenu new.
	menu addElement: (ARMenuItem new name: 'Home'; link: 'index.html'; yourself).
	menu addElement: (ARMenuItem new name: 'Publications'; link: 'Publications.html'; yourself).
	menu addElement: (ARMenuItem new name: 'Coordinates'; link: 'Coordinates.html'; yourself).
	"in the future the link should be computed based on the site"
	^ menu
	! !

!StefSite class methodsFor: 'create site' stamp: 'StephaneDucasse 1/4/2012 09:39'!
site
	"self site"
	
	page := ARPage new.
	page addElement: self menu.
	page addElement: self main.
	^ page
	! !
